import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;

public class PrinceGameCanvas extends GameCanvas implements Runnable, CommandListener
{
    private boolean isPlay;     // Game Loop runs when isPlay is true
    private boolean isPause;    // Game Loop pause when isPause is true
    private Command exitCommand   = new Command("Exit", Command.EXIT,1);
    private Command pauseCommand  = new Command("Pause", Command.SCREEN,1);
    private Command resumeCommand = new Command("Resume",Command.SCREEN,1);
    private PrinceTiledLayer midlet;
    private long delay;         // To give thread consistency
    private int width;          // To hold screen width
    private int height;         // To hold screen height
    private int[] FSRun0  = {0,1,2,3,4,5,6,7,8,9,10,11,12};
    private int[] vectorZero={0,0,0,0,0,0,0,0,0,0,0,0,0};
    private char FSRun0_L = 6;
    private int[] FSRun1  = {6,7,8,9,10,11,12};
    private int[] FSRun2     = {14,17,19,20,20,26,28,31,0};
    private int[] D2UvectorX = { 0, 0, 0,17,38,15,15, 1};
    private int[] D2UvectorY = { 0, 0, 0, 0,14, 5,14, 8};  
    private char FSRun2_L = 10;
    private int[] FSRun3     = { 0,32,30,27,25,20, 0};
    private int[] U2DvectorX = { 6,17, 0, 0, 0, 0};
    private int[] U2DvectorY = { 4,11,15,17,27,14};     
    private int[] FSDown     = {20,20,20,20,20,20,20,20,20,20,20,20,20,20};
    private int[] DownVectorX= { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    private char FSRun3_L = 32;
    private int screenY = 0;
    private int screenX = 0;
    private int FS = 0;
    private boolean Down = false;
    private boolean Down2= false;
    private boolean Up = false;
    private boolean Dir = false;
    private char old;
    private PrinceSprite sprite;
    // Layer Manager
    private LayerManager layerManager;
    // TiledLayer
    private TiledLayer tiledBackground;
    private TiledLayer tiledColumn;
    //private TiledLayer tiledWall;
    // Constructor and initialization
    public PrinceGameCanvas(PrinceTiledLayer midlet) throws Exception
    {
        super(true);
        this.midlet=midlet;
        addCommand(exitCommand);
        addCommand(pauseCommand);
        setCommandListener(this);
        isPlay=true;
        isPause=false;        
	width = getWidth();
        height = getHeight();
        delay = 50;
        Image image = Image.createImage("/sp2.png");
        sprite = new PrinceSprite (image,32,54);
        sprite.setPosition(45, -13);
        tiledBackground = initBackground();
        tiledColumn = initColumn();
        layerManager = new LayerManager();
        layerManager.append(tiledColumn);
        //layerManager.append(sprite);
        layerManager.append(tiledBackground);
        sprite.setFrameSequence(FSRun0,vectorZero,vectorZero);
    }
    // Automatically start thread for game loop
    public void start()
    {
        isPlay = true;
        Thread t = new Thread(this);
        t.start();
    }
    public void stop()
    { isPlay = false; }
    // Main Game Loop
    public void run() {
        Graphics g = getGraphics();
        while (isPlay == true) {
            input();
            drawScreen(g);
            try {
                Thread.sleep(delay);
            } catch (InterruptedException ie) {
            }
        }
    }
    // Method to Handle User Inputs
    private void input()
    {
        int keyStates = getKeyStates();
        if(Down)
        {
            sprite.nextFrame();
            sprite.move(0, 3);
            if (sprite.Last())
            {
                Down = false;
                sprite.move(0, 5);
                if (!sprite.Fail(tiledBackground))
                {
                    sprite.setFrameSequence(FSRun0,vectorZero,vectorZero);
                    FS = 0;
                }
            }            
        }else if(Up)
        {
            sprite.nextFrame();
            sprite.move(0, -3);
            if (sprite.Last())
                Up = false;
        }else if(Down2)
        {
            sprite.nextFrame();
            if (sprite.Last())
                Down2 = false;
        }
        // Left
        else if ((keyStates & LEFT_PRESSED) != 0 )
        {
            if(old!='D')
                sprite.nextFrame();
            if (sprite.getFrame()==FSRun0_L && FS==0)
            {
                FS = 1;
                sprite.setFrameSequence (FSRun1,vectorZero,vectorZero);
            }
            if (Dir){
                FS = 0;
                sprite.setFrameSequence(FSRun0,vectorZero,vectorZero);
                sprite.setTransform(0);
                //sprite.setFrame(0);
            }
            if (sprite.Fail(tiledBackground))
            {
                if(old!='D')
                    sprite.move(5*(sprite.getTransform()-1),0);
                Down = true;
                sprite.setFrameSequence(FSDown,vectorZero,vectorZero);
                old='D';
            }
            if (!sprite.collidesWith(tiledBackground,-2, 0)) {
                //spriteX = Math.max(0, spriteX - 2);
                if (old!='D')    
                    sprite.move(-2, 0);
                old = 'L';
            }
            if (sprite.collidesWith(tiledColumn,0, 0)) {
                Delaytime(2000);
                //spriteX = Math.max(0, spriteX - 2);
                sprite.move(-40, 0);
            }
            Dir = false;
        }
        // Right
        else if ((keyStates & RIGHT_PRESSED) !=0 ){
            if(old!='D')
                sprite.nextFrame();
            if (sprite.getFrame()==FSRun0_L && FS==0)
            {
                FS = 1;
                sprite.setFrameSequence (FSRun1,vectorZero,vectorZero);
            }
            if (Dir==false){
                FS = 0;
                //sprite.setFrame(0);
                sprite.setFrameSequence(FSRun0,vectorZero,vectorZero);
                sprite.setTransform(2);
            }
            if (sprite.Fail(tiledBackground))
            {
                if (old!='D')
                    sprite.move(10*(sprite.getTransform()-1),0);
                Down = true;
                sprite.setFrameSequence(FSDown,DownVectorX,vectorZero);
                old='D';
            }
            if (!sprite.collidesWith(tiledBackground,2, 0)) {
                //spriteX = Math.min(width, spriteX + 2);
                if (old!='D')
                    sprite.move(2, 0);
                old = 'R';
            }
            if (sprite.collidesWith(tiledColumn,40, 0)) {
                    Delaytime(2000);
                    //spriteX = Math.min(width, spriteX + 2);
                    sprite.move(40, 0);
            }
            Dir = true;
        }
        // Up
        else if ((keyStates & UP_PRESSED) != 0) {
            FS=2;
            sprite.setFrameSequence(FSRun2,D2UvectorX,D2UvectorY);
            sprite.nextFrame();
            if (!sprite.UDcollidesWith(tiledBackground,sprite.vectorX[sprite.getFrame()], sprite.vectorY[sprite.getFrame()])) {
                sprite.nextFrame();
                //spriteY = Math.max(0, spriteY - 2);
            }
        }
        // Down
        else if ((keyStates & DOWN_PRESSED) !=0){
            if (old=='L' | old=='R'){
                if (sprite.getTransform()==2)
                    sprite.setTransform(0);
                else sprite.setTransform(2);
            }
                
            if (sprite.CGD(tiledBackground,10, 40, 15, 10))
            {
                old='D';
                sprite.setFrameSequence(FSRun3,U2DvectorX,U2DvectorY);
                Down2 = true;
            }
        }
        else if (keyStates==0)
        {
            FS=0;
            sprite.setFrameSequence(FSRun0,vectorZero, vectorZero);
            if (sprite.Fail(tiledBackground))
            {   
                if (old=='L' | old=='R')
                    sprite.move(5*(sprite.getTransform()-1),0);
                Down =true;
                sprite.setFrameSequence(FSDown, DownVectorX, vectorZero);
                old='D';
            }
        }       
    }
    // Method to Display Graphics
    private void drawScreen(Graphics g)
    {
        g.setColor(0x0);
        g.fillRect(0, 0, getWidth(), getHeight());
        g.setColor(0x0000ff);
        SCreenCheck();
        layerManager.paint(g,0,0);//screenX,screenY);
        //sprite.setPosition(spriteX, spriteY);
        sprite.paint(g);
        flushGraphics();
    }
    private TiledLayer initColumn() throws Exception
    {
        Image tileImages = Image.createImage("/screen_final.png");
        TiledLayer tiledLayer = new TiledLayer(10,10,tileImages,22,44);
        int[] map = {
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 7, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0
        };
        for (int i=0; i < map.length; i++) {
            int column = i % 10;
            int row = (i - column) / 10;
            tiledLayer.setCell(column,row,map[i]);
        }
        return tiledLayer;
    }
    private TiledLayer initBackground() throws Exception
    {
        Image tileImages = Image.createImage("/screen_final.png");
        TiledLayer tiledLayer = new TiledLayer(10,10,tileImages,22,44);
        int[] map = {
             1, 2, 3, 4, 9, 0, 6,13,16, 1,
             1, 1, 1, 2,11, 0,16, 1, 1, 1,
             0, 0, 0, 6, 5, 5,16, 1, 1, 1,
             4, 9, 0,16, 1, 1, 1, 1, 1, 1,
             2, 3, 5, 4, 4, 9, 0, 6, 1, 1,
             1, 1, 1, 1, 2,11, 0,16, 1, 1,
             2, 3, 5,13, 4, 4, 9, 0,16, 1,
             1, 1, 1, 1, 1, 2,11, 0,16, 1,
             0, 6, 8, 8, 4,13, 4, 4,16, 1,
             5,16, 1, 1, 1, 1, 1, 1, 1, 1
        };
        for (int i=0; i < map.length; i++) {
            int column = i % 10;
            int row = (i - column) / 10;
            tiledLayer.setCell(column,row,map[i]);
        }
        return tiledLayer;
    }
    private void SCreenCheck()
    {
        int spriteX = sprite.getX();
        int spriteY = sprite.getY();
        
        if (spriteX>(width-20))
        {
            spriteX -= width/2;
            screenX -= width/2;
            tiledBackground.setPosition(screenX, screenY);
            tiledColumn.setPosition(screenX, screenY);
        }
        if (spriteX < 20)
        {
            if (screenX+width/2<1)
            {
                spriteX += width/2;
                screenX += width/2; 
                tiledBackground.setPosition(screenX, screenY);
                tiledColumn.setPosition(screenX, screenY);
            }
        }
        if (spriteY>(2*height/3-20))
        {
            spriteY -= height/3;
            screenY -= height/3; 
            tiledBackground.setPosition(screenX, screenY);
            tiledColumn.setPosition(screenX, screenY);
        }
        if (spriteY < 20)
        {
            if (screenY+height/2<1)
            {
                spriteY += height/2;
                screenY += height/2; 
                tiledBackground.setPosition(screenX, screenY);
                tiledColumn.setPosition(screenX, screenY);
            }
        }
        sprite.setPosition(spriteX, spriteY);
        if ((spriteY-screenY)>360)
        {
            this.midlet.Win();
            Delaytime(99999);
            this.midlet.exitGame();
        }
    }
    public void commandAction(Command c, Displayable d)
    {
		if (c == exitCommand)
			this.midlet.exitGame();
		if (c == pauseCommand)
			pauseGame();
		if (c == resumeCommand)
			resumeGame();
	}
	public void autoSave()
    {
	}
	public void pauseGame()
    {
		// You may or may not want to have auto-save done at Pause, that is why when you;
		//exit;
		// the system console outpus and extra 2 auto saving messages, total 3 including the;
		// the call to autosave when exiting;
		autoSave();
		removeCommand(pauseCommand);
		addCommand(resumeCommand);
		isPause=true;
		stop();
	}
	public void resumeGame()
    {
		removeCommand(resumeCommand);
		addCommand(pauseCommand);
		isPause=false;
		start();
	}
	public void hideNotify()
    {
		pauseGame();
	}
	public void showNotify()
    {
		resumeGame();
	}
    public void Delaytime(int DelayCount)
    {
		for (int i=0 ; i < DelayCount ; i++)
            for (int j=10;j>0;j--);
	}
        
}
