import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.TiledLayer;

public class PrinceSprite extends Object
{
    public static final int TRANS_MIRROR = 2; 
    public static final int TRANS_MIRROR_ROT180 = 1; 
    public static final int TRANS_MIRROR_ROT270 = 4; 
    public static final int TRANS_MIRROR_ROT90 = 7; 
    public static final int TRANS_NONE = 0; 
    public static final int TRANS_ROT180 = 3; 
    public static final int TRANS_ROT270 = 6; 
    public static final int TRANS_ROT90 = 5; 
    private Image image;
    private int positionX;
    private int positionY;
    private int frameWidth;
    private int frameHeight;
    private int numFrames;
    private int currentFrame;   
    private boolean visible;
    private int transform;
    private int[] FrameSeq = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,17,19,20,21,22,23,24,25,26,27,28,29,30,31};
    public int[] vectorX={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
    public int[] vectorY={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
    private static final int BASELINE = 64; 
    private static final int BOTTOM = 32; 
    private static final int DOTTED = 1; 
    private static final int HCENTER = 1; 
    private static final int LEFT = 4; 
    private static final int RIGHT = 8; 
    private static final int SOLID = 0; 
    private static final int TOP = 16; 
    private static final int VCENTER = 2; 
    public PrinceSprite(Image image, int frameWidth, int frameHeight) throws Exception
    {
        this.image = image;
        this.frameWidth = frameWidth;
        this.frameHeight = frameHeight;
        this.numFrames = image.getWidth()/frameWidth;
    }
    public int getX()
    {
        return this.positionX;
    }
    public void setX(int positionX)
    {
        this.positionX = positionX;
    }
    public int getY()
    {
        return this.positionY;
    }
    public void setY(int positionY)
    {
        this.positionY = positionY;
    }
    public void setPosition(int pX ,int pY)
    {
        this.positionX = pX;
        this.positionY = pY;
    }
    public boolean isVisible()
    {
        return this.visible;
    }
    public void paint(Graphics g)
    {
        g.drawRegion(this.image, this.frameWidth * this.FrameSeq[this.currentFrame],
                0, this.frameWidth, this.frameHeight, this.transform,
                this.positionX, this.positionY,  TOP|LEFT);
    }    
    public void setVisible(boolean visible)
    {
        this.visible = visible;
    }
    public void move(int dx,int dy)
    {
        this.positionX += dx;
        this.positionY += dy;
    }
    public int getHeight()
    {
        return this.frameHeight;
    }
    public int getwidth()
    {
        return this.frameWidth;
    }
    public void setTransform(int transform)
    {
        this.transform = transform;
    }
     public int getTransform()
    {
        return this.transform;
    }
    public void setFrameSequence(int[] sequence,int[] vectorX,int[] vectorY)
    {
        char i;
        this.numFrames = sequence.length;
        this.vectorX = vectorX;
        this.vectorY = vectorY;
        for(i=0;i<this.numFrames;i++)
        {
            this.FrameSeq[i] = sequence[i];
        }
        this.currentFrame = 0;
    }
    public void nextFrame()
    {
        if (this.currentFrame < (this.numFrames - 1)) {
            this.positionX += (1-this.getTransform())*this.vectorX[this.currentFrame];
            this.positionY += this.vectorY[this.currentFrame];
            this.currentFrame++;
	}
        else
            this.currentFrame = 0;
    }
    public void prevFrame()
    {
        if (this.currentFrame > 0) {
            this.positionX -= (1-this.getTransform())*this.vectorX[this.currentFrame];
            this.positionY -= this.vectorY[this.currentFrame];
            this.currentFrame--;
	}
        else
            this.currentFrame = this.numFrames - 1;
    }
    public int getFrame()
    {
        return this.currentFrame;
    }
    public void setFrame(int FrameNum)
    {
        this.currentFrame = FrameNum;        
    }
    public boolean collidesWith(TiledLayer Layer, int dx, int dy)
    {
        int LX = -Layer.getX();
        int LY = -Layer.getY() + 17;
        int i  = (this.positionX+LX+dx)/Layer.getCellWidth();
        int i_2= (this.positionX+LX+dx+this.frameWidth)/Layer.getCellWidth();
        int j  = (this.positionY+LY+dy)/Layer.getCellHeight();
        LX = Layer.getCell(i, j);
        LY = Layer.getCell(i_2, j);
        if (LX==1 | LX==2 | LX==7 | LX==16 | LY==1 | LY==2 | LY==16 )
            return true;
        else
            return false;
    }
	public boolean UDcollidesWith(TiledLayer Layer, int dx, int dy)
    {
        int i  = (this.positionX+dx)/Layer.getCellWidth();
        int i_2= (this.positionX+dx+this.frameWidth)/Layer.getCellWidth();
        int j  = (this.positionY+dy)/Layer.getCellHeight();
        int LX = Layer.getCell(i, j);
        int LY = Layer.getCell(i_2, j);
        if (LY==9 | LY==12 | LY==11 | LY==0 )
            return false;
        else
            return true;
    }
    public boolean Last()
    {
        if (this.currentFrame==this.numFrames - 1)
            return true;
        return false;
    }
    public boolean Fail(TiledLayer Layer)
    {
        int LX = -Layer.getX();
        int LY = -Layer.getY() + 25;
        int i  = (this.positionX+LX+this.frameWidth/2)/Layer.getCellWidth();
        int j  = (this.positionY+LY)/Layer.getCellHeight();
        LX = Layer.getCell(i, j);
        if (LX==3 | LX==4 | LX==5 | LX==6 | LX==7 | LX==8 | LX==13 | LX==14 | LX==15)
            return false;
        else
            return true;       
    }
	public boolean CGD(TiledLayer Layer, int Vx, int Vy, int dx, int dy)
    {
        int rx = this.positionX+Vx-Layer.getX();
        int ry = this.positionY+Vy-Layer.getY();
        int Cel1  = Layer.getCell((rx+dx)/Layer.getCellWidth(), (ry+dy)/Layer.getCellHeight());
        int Cel3  = Layer.getCell((rx+dx)/Layer.getCellWidth(), (ry+dy)/Layer.getCellHeight());;
        int Cel4  = Layer.getCell((rx+dx)/Layer.getCellWidth(), (ry+dy)/Layer.getCellHeight());;
        if ((Cel4==9 & Cel3!=12 & Cel1!=11) | (Cel4==6 & Cel3!=16) )
            return true;
        else
            return false;
    }
}
